function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* Copyright (c) 2015-present, salesforce.com, inc. All rights reserved */

/* Licensed under BSD 3-Clause - see LICENSE.txt or git.io/sfdc-license */
import React from 'react';
import PropTypes from 'prop-types';
import Combobox from '../../combobox/combobox';

var DatepickerYearSelector =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DatepickerYearSelector, _React$Component);

  function DatepickerYearSelector() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, DatepickerYearSelector);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DatepickerYearSelector)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getOptions", function () {
      var now = new Date();

      var fromYear = now.getFullYear() + _this.props.relativeYearFrom;

      var toYear = now.getFullYear() + _this.props.relativeYearTo;

      var opts = []; // eslint-disable-next-line fp/no-loops

      for (var year = fromYear; year < toYear; year += 1) {
        // eslint-disable-next-line fp/no-mutating-methods
        opts.push({
          label: "".concat(year),
          value: year,
          id: String(opts.length)
        });
      }

      return opts;
    });

    _defineProperty(_assertThisInitialized(_this), "getSelectedValueOption", function () {
      var selectedYear = _this.props.initialDateForCalendarRender.getFullYear();

      return _this.getOptions().filter(function (option) {
        return option.value === selectedYear;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelect", function (event, _ref) {
      var selectedValues = _ref.selection;
      var selectedValue = selectedValues[0]; // safe since we are working with a single selection

      if (selectedValue) {
        _this.props.onChangeMonth(new Date(_this.props.initialDateForCalendarRender.setFullYear(parseInt(selectedValue.value, 10))));
      }
    });

    return _this;
  }

  _createClass(DatepickerYearSelector, [{
    key: "render",
    value: function render() {
      var selection = this.getSelectedValueOption();
      return React.createElement("div", {
        className: "slds-form-element slds-align-content-center"
      }, React.createElement(Combobox, {
        assistiveText: {
          label: this.props.assistiveTextYear
        },
        className: "slds-shrink-none",
        classNameMenu: "slds-datepicker",
        events: {
          onSelect: this.handleSelect
        },
        id: "".concat(this.props.id, "-year-picklist"),
        inheritWidthOf: "target",
        menuPosition: "relative",
        multiple: false,
        options: this.getOptions(),
        labels: {
          placeholder: 'Year'
        },
        selection: selection,
        value: selection.value,
        variant: "readonly"
      }));
    }
  }]);

  return DatepickerYearSelector;
}(React.Component);

_defineProperty(DatepickerYearSelector, "displayName", 'SLDSDatepickerYearSelector');

_defineProperty(DatepickerYearSelector, "propTypes", {
  /**
   * Label for year picklist/combobox
   */
  assistiveTextYear: PropTypes.string.isRequired,

  /**
   * HTML id for component
   */
  id: PropTypes.string,

  /**
   * Date used to create calendar that is displayed. This is typically the initial day focused when using the keyboard navigation. Focus will be set to this date if available.
   */
  initialDateForCalendarRender: PropTypes.instanceOf(Date).isRequired,

  /**
   * Displayed calendar has changed or re-rendered
   */
  onChangeMonth: PropTypes.func.isRequired,

  /**
   * Offset of year from current year that can be selected in the year selection dropdown. (2017 - 5 = 2012).
   */
  relativeYearFrom: PropTypes.number,

  /**
   * Offset of year from current year that can be selected in the year selection dropdown. (2017 + 5 = 2012).
   */
  relativeYearTo: PropTypes.number
});

export default DatepickerYearSelector;
//# sourceMappingURL=year-picklist.js.map